---
# tasks file for roles/elastic

- name: Set alias command for root
  lineinfile:
    dest: ~/.bashrc
    line:  "{{item}}"
    state: present
    insertafter: EOF
  with_items: 
    - "alias logs='docker-compose logs -f'"
    - "alias up='docker-compose up -d'"
    - "alias recreate='docker-compose up -d --force-recreate'"
    - "alias dockerps='docker ps -a'"
    - "alias images='docker images'"
    - "alias exec='docker exec -it'"
  become: true
  become_user: root

- name: Create a network
  docker_network:
    name: elastic
    driver: bridge
  ignore_errors: yes

- name: install elasticsearch
  docker_container:
    name: elasticsearch
    image: docker.elastic.co/elasticsearch/elasticsearch:7.2.1
    detach: yes
    networks:
      - name: "elastic"
    state: started
    env:
      discovery.type: single-node
    ports:
      - "9200:9200"
      - "9300:9300"
  ignore_errors: yes

- name: install kibana
  docker_container:
    name: kibana
    image: docker.elastic.co/kibana/kibana:7.2.1
    detach: yes
    networks:
      - name: "elastic"
    state: started
    ports:
      - "5601:5601"
  ignore_errors: yes
- name: copy file to server 
  copy:
    src: "{{item}}"
    dest: "/srv/"
  with_items:
    - apm-server.docker.yml
    - filebeat.docker.yml
    - heartbeat.docker.yml
  ignore_errors: yes
- name: install filebeat
  command: docker run -d --name=filebeat --network="elastic" --user=root --volume="/srv/filebeat.docker.yml:/usr/share/filebeat/filebeat.yml:ro" --volume="/var/lib/docker/containers:/var/lib/docker/containers:ro" --volume="/var/run/docker.sock:/var/run/docker.sock:ro" docker.elastic.co/beats/filebeat:7.3.0 filebeat --strict.perms=false -E output.elasticsearch.hosts=["elasticsearch:9200"]
  args: 
    chdir: "/srv"
  ignore_errors: yes

- name: install apm-server
  command: docker run -d --network="elastic" --name=apm-server --user=apm-server -p 8200:8200 --volume="/srv/apm-server.docker.yml:/usr/share/apm-server/apm-server.yml:ro" docker.elastic.co/apm/apm-server:7.3.0 --strict.perms=false -e -E output.elasticsearch.hosts=["elasticsearch:9200"]
  args: 
    chdir: "/srv"
  ignore_errors: yes

- name: install heartbeat
  command: docker run -d --name=heartbeat --user=heartbeat --volume="/srv/heartbeat.docker.yml:/usr/share/heartbeat/heartbeat.yml:ro" --network="elastic" docker.elastic.co/beats/heartbeat:7.2.1 --strict.perms=false -e -E output.elasticsearch.hosts=["elasticsearch:9200"]
  args: 
    chdir: "/srv"
  ignore_errors: yes
